#!/bin/bash
ADVISE_MSG="You must add SN parameter. For exemple : $0 2024092001412"

if [ -z "$1" ]; then
	echo "First parameter can't be empty. $ADVISE_MSG"
	exit 1
fi
echo "$1" |grep -v "[[:alpha:]]" > /dev/null
if [[ $? -eq 1 ]]; then
	echo "First parameter, gesa_sn must be a integer. $ADVISE_MSG"
	exit 1
fi
if [[ "$1" -lt "2024092000000" ]]; then
	echo "First parameter, must be a correct gesa_sn. This integer isn't a correct SN. $ADVISE_MSG"
	exit 1
fi

echo $1 > /etc/gesa/sn 2>&1 || exit 1
chmod 644 /etc/gesa/sn 2>&1 || exit 1
chown root:root /etc/gesa/sn 2>&1 || exit 1

rm /home/techesia/.ssh/authorized_keys
echo "RUN SUCCESS"
shutdown -r +1
rm "$0"

exit 0
