<?php
/**
*** @name: dialog.php
***
*** @description: controller for dialog windows
*** @author: Quentin George <q.george@esia-sa.com>
*** @date: 08/05/2023
**/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/common.php';

// Action
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
	$action = $_POST['action'];
}

$isJSONResp = FALSE;
if(isset($_POST['isJSON']))
{
	$isJSONResp = TRUE;
}

$errors = array();
try
{
	if($action == 'deleteIface')
	{
		if(isset($_POST['confirmId']) && $_POST['confirmId'] == $_GET['id'])
		{
			/*
			** Validation form sended
			*/
			$isJSONResp = TRUE;
			if(empty($_POST['confirmId']))
			{
				throw new Exception($lang['ERR_MISSING_IFACE_DATA']);
			}
			$taggedIndex = str_replace('_', '.', $_POST['confirmId']);

			// Save inside data file
			$netConf = getJsonConfFile($path . DATA_DIR . NETWORK_CONF_FILE);
			// Remove interface key
			unset($netConf[$taggedIndex]);
			// Save into file
			$isWritten = setJsonConfFile($path . DATA_DIR . NETWORK_CONF_FILE, $netConf);
			if($isWritten == FALSE)
			{
				throw new Exception($lang['ERR_SAVE_IFACE_DATA']);
			}
			
			echo json_encode($lang['PARAMS_IFACE_DELETE_SUCCESS']);
			exit(0);
		}
		else
		{
			/*
			** Display html content
			*/
			$ifaceId = '';
			if(isset($_POST['jsonKey']))
			{
				$ifaceId = str_replace('.', '_', $_POST['jsonKey']);
			}
			$smarty->assign('ifaceId', $ifaceId);
		}
	}
	elseif($action == 'reboot')
    {
		if(isset($_POST['confirmDel']))
		{
			/*
			** Validation sended
			*/
			exec('sudo shutdown -r now', $output, $code);
			if($code != 0)
			{
				throw new Exception($lang['ERR_SYSTEM']);
			}

			echo json_encode('');
			exit(0);
		}
		else
		{
			/*
			** Display html content
			*/
		}
    }
}
catch(Exception $e)
{
	if($isJSONResp == TRUE)
	{
		echo json_encode(array('error' => $e->getMessage()));
		exit(0);
	}
	else
	{
		$errors[] = $e->getMessage();
	}
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);

$smarty->display(TPL_PATH . 'dialog.html');

?>
