<?php
/**
*** @name protocols.php
**/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';

$smarty->assign('section', 'protocols');

$tab = '';
if(!empty($_REQUEST['tab']))
{
	$tab = $_REQUEST['tab'];
}

$subtab = '';
if(!empty($_REQUEST['subtab']))
{
	$subtab = $_REQUEST['subtab'];
}

try
{
	if($tab == 'ssh')
	{
		if($action == 'show')
		{
/*
            // Get main ssh conf file
            $mainConfSSH = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['ssh']);
            $mainConfSSH['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['ssh'];
            $smarty->assign('mainConfSSH', $mainConfSSH);

            // List users files
            $listConfSSH = array();
            $listFilesSSH = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.ssh.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['ssh']));
            foreach($listFilesSSH as $file)
            {
                $conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
                $conf['fileName'] = $file;
                $listConfSSH[] = $conf;
            }
            $smarty->assign('listConfSSH', $listConfSSH);
*/
            // Get ssh pub keys
            $listPubKeys = array();
            $listPubKeysFiles = getFilesListByNameEnd(GESA_SSH_KEYS_DIR, '.pub');
            foreach($listPubKeysFiles as $file)
            {
                $listPubKeys[$file] = trim(file_get_contents(GESA_SSH_KEYS_DIR . $file));
            }
            $smarty->assign('listPubKeys', $listPubKeys);
		}
	}
	elseif($tab == 'powershell')
	{
		if($action == 'show')
		{
            // Get main powershell conf file
            $mainConfPW = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['powershell']);
            $mainConfPW['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['powershell'];
            $smarty->assign('mainConfPW', $mainConfPW);

            // List users files
            $listConfPW = array();
            $listFilesPW = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.pwsh.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['powershell']));
            foreach($listFilesPW as $file)
            {
                $conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
                $conf['fileName'] = $file;
                $listConfPW[] = $conf;
            }
            $smarty->assign('listConfPW', $listConfPW);
		}
	}
	elseif($tab == 'ipmi')
	{
		if($action == 'show')
		{
            // Get main ipmi conf file
            $mainConfIPMI = getTxtConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['ipmi'], ' ');
            $mainConfIPMI['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['ipmi'];
            if(in_array($mainConfIPMI['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']))
            {
                $mainConfIPMI['driver-type'] = array_search($mainConfIPMI['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
            }
            $smarty->assign('mainConfIPMI', $mainConfIPMI);

            // List users files
            $listConfIPMI = array();
            $listFilesIPMI = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.ipmi.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['ipmi']));
            foreach($listFilesIPMI as $file)
            {
                $conf = getTxtConfFile(PLUGINS_CONF_FILES_DIR . $file, ' ');
                $conf['fileName'] = $file;
                if(in_array($conf['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']))
                {
                    $conf['driver-type'] = array_search($conf['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
                }
                $listConfIPMI[] = $conf;
            }
            $smarty->assign('listConfIPMI', $listConfIPMI);

            $smarty->assign('listPriv', PROTOCOLS_CONF_AVAILABLE['ipmi']['privileges']);
            $smarty->assign('listVersions', PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
		}
	}
	elseif($tab == 'virt')
	{
		if(!$gesa->getIsVM())
		{
			$smarty->assign('no_header', TRUE);
			$smarty->display(TPL_PATH . 'no_access.html');
			exit(0);
		}

		if($action == 'show')
		{
            // Get main virt conf file
            $mainConfVirt = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['virt']);
            $mainConfVirt['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['virt'];
            $smarty->assign('mainConfVirt', $mainConfVirt);

            // List users files
            $listConfVirt = array();
            $listFilesVirt = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.virt.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['virt']));
            foreach($listFilesVirt as $file)
            {
                $conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
                $conf['fileName'] = $file;
                $listConfVirt[] = $conf;
            }
            $smarty->assign('listConfVirt', $listConfVirt);
		}
	}
	elseif($tab == 'backup')
	{
		if(!$gesa->getIsVM())
		{
			$smarty->assign('no_header', TRUE);
			$smarty->display(TPL_PATH . 'no_access.html');
			exit(0);
		}

		if(!empty($subtab) && $action == 'show')
		{
			// Get main backup conf file
			$mainConfBck = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['bck'][$subtab]);
			$mainConfBck['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['bck'][$subtab];
			$smarty->assign('mainConfBck', $mainConfBck);

			// List users files
			$listConfBck = array();
			$listFilesBck = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.' . $subtab . '.bck.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['bck'][$subtab]));
			foreach($listFilesBck as $file)
			{
				$conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
				$conf['fileName'] = $file;
				$listConfBck[] = $conf;
			}
			$smarty->assign('listConfBck', $listConfBck);

			$defaultConf = array();
			if($subtab == 'appassure')
			{
				$defaultConf = array(
					'port' => 8161,
				);
			}
			elseif($subtab == 'proxmox')
			{
				$defaultConf = array(
					'url' => 'https://127.0.0.1:8007',
					'username' => 'root@pam',
				);
			}
			elseif($subtab == 'veeam')
			{
				$defaultConf = array(
					'port' => 1433,
					'dbname' => 'esia',
					'dbuser' => 'esia',
				);
			}
			elseif($subtab == 'veeam365')
			{
				$defaultConf = array(
					'url' => 'https://127.0.0.1:4443',
				);
			}
			$smarty->assign('defaultConf', $defaultConf);
		}
    }
}
catch(GesaException | Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);
$smarty->assign('tab', $tab);
$smarty->assign('subtab', $subtab);
$smarty->assign('PLUGINS_CONF_FILES_DIR', PLUGINS_CONF_FILES_DIR);
$smarty->assign('GESA_SSH_KEYS_DIR', GESA_SSH_KEYS_DIR);

$smarty->display(TPL_PATH . 'protocols.html');

?>
