#!/bin/bash
scriptname=$(basename $0)
[[ -z $1 ]] && echo "Login parameter is missing. Usage is $scriptname <login> <pass>" && exit 1
[[ -z $2 ]] && echo "Password parameter is missing. Usage is $scriptname <login> <pass>" && exit 1

USERNAME="$1"
if [ "$USERNAME" != "esia" ]; then
	echo "Unauthorized Username"
	exit 1
fi

export PASSWD="$2"
ORIGPASS=`grep -E "^$USERNAME:" /etc/passwd | cut -d: -f2`
if [ "$ORIGPASS" == "x" ]; then
	ORIGPASS=`grep -E "^$USERNAME:" /etc/shadow | cut -d: -f2`
fi

if [ -z "$ORIGPASS" ]; then
	[[ ! -r "/etc/shadow" ]] && echo "Password file unreacheable" && exit 1
	grep -E "^$USERNAME:" /etc/shadow
	[[ $? -eq 1 ]] && echo "Login $USERNAME not found" && exit 1
	echo "Unable to get shadow string password" && exit 1
fi

export ALGO=`echo $ORIGPASS | cut -d"$" -f2`
export SALT=`echo $ORIGPASS | cut -d"$" -f3`

if [ "$ALGO" == "y" ]; then
	export ALGO=`echo $ORIGPASS | cut -d"$" -f2,3`
	export SALT=`echo $ORIGPASS | cut -d"$" -f4`
fi

GENPASS="$(perl -e 'print crypt("$ENV{PASSWD}","\$$ENV{ALGO}\$$ENV{SALT}\$")')" 

if [ "$3" == "debug" ]; then
	echo "algo: -$ALGO-"
	echo "salt: -$SALT-"
	echo "pw entré: -$PASSWD-"
	echo "shadow: -$ORIGPASS-"
	echo "pass génére: -$GENPASS-"
fi

if [ "$GENPASS" == "$ORIGPASS" ]; then
       echo "Valid Password"
       exit 0
else
       echo "Invalid Password"
       exit 1
fi
